﻿----------------------------------------------------------------------------------------------------
-- DroodFocus 4.1.3 - timerbars
-- Meranannon - Discordia - Vol'jin (EU)
-- rev 1
----------------------------------------------------------------------------------------------------

local DF = DF_namespace

local frames={}
local nbSpells = 0
local barsOrder = {}
local restant
local cd1=0
local dur1=0
local cd2=0
local dur2=0	
local rt1=0
local rt2=0

-- initialisation frames
function DF:init_timerbars_frame()

--	if DF_config.timerbar.stackup1==nil then
--		DF_config.timerbar.stackup1 = DF_config.timerbar.stackup
--		DF_config.timerbar.stackup2 = DF_config.timerbar.stackup
--	end
--
--	if DF_config.timerbar.width2==nil then
--		DF_config.timerbar.width2 = DF_config.timerbar.width
--		DF_config.timerbar.height2 = DF_config.timerbar.height
--	end
--
--	if DF_config.timerbar.activeAlpha2==nil then
--		DF_config.timerbar.activeAlpha2 = DF_config.timerbar.activeAlpha
--		DF_config.timerbar.inactiveAlpha2 = DF_config.timerbar.inactiveAlpha
--	end
--
--	if DF_config.timerbar.activeAlphaCD2==nil then
--		DF_config.timerbar.activeAlphaCD2 = DF_config.timerbar.activeAlphaCD
--	end

	
	nbSpells = getn(DF_config.spells)

	for i = 1,getn(frames) do
		
		if i>nbSpells then
			frames[i].frame:Hide()
		end
		
	end
	
	for i = 1,nbSpells do

		if not frames[i] then

			frames[i]={}
			frames[i].texts={}
			if DF_config.spells[i].timerbar==0 then
				frames[i].useConfig=1
			else
				frames[i].useConfig=DF_config.spells[i].timerbar
			end
			frames[i].state=0
			frames[i].alpha=1
			
			-- cadre principal
			frames[i].frame = CreateFrame("FRAME","DF_TIMERBAR_FRAME"..i,DF.anchor[3].frame)
			frames[i].frame:SetScript("OnMouseDown",function(self,button)
					if button=="RightButton" then
						DF:options_DebuffList_fakeClick(i)
		  			if IsControlKeyDown() then
			  			DF:options_show("spells",nil,true)
			  		else
		  				DF:options_show("timerbar",frames[i].frame,true)
		  			end
		  		end
			end)
			frames[i].frame:SetScript("OnEnter",function(self,button)
				if DF.configmode then
					GameTooltip:SetOwner(UIParent, "ANCHOR_TOPLEFT ",16,-16)
					GameTooltip:ClearLines()
					GameTooltip:AddLine("DROODFOCUS TIMERBAR",1,1,0,nil)
					GameTooltip:AddLine(DF_config.spells[i].abiSpelltext,1,1,1,nil)
					GameTooltip:AddLine(DF.locale["rightMB"],1,1,1,nil)
					GameTooltip:AddLine(DF.locale["ctrlrightMB"],1,1,1,nil)
					GameTooltip:Show()		
				end		
			end)		
			frames[i].frame:SetScript("OnLeave",function(self,button)
				if DF.configmode then GameTooltip:Hide() end
			end)		
							
			-- cadre pour la texture
			frames[i].background = CreateFrame("StatusBar","DF_TIMERBAR_BACKGROUND"..i,frames[i].frame)
			frames[i].foreground = CreateFrame("StatusBar","DF_TIMERBAR_FOREGROUND"..i,frames[i].frame)
			frames[i].cooldown = CreateFrame("StatusBar","DF_TIMERBAR_cooldown"..i,frames[i].frame)
			frames[i].spark =  CreateFrame("FRAME","DF_TIMERBAR_SPARK"..i,frames[i].foreground)
			
			for te = 1,2 do
				frames[i].texts[te] = frames[i].foreground:CreateFontString("DF_TIMERBAR"..i.."_TEXT"..te,"ARTWORK")
			end
			frames[i].frame:EnableMouse(false)
			frames[i].frameTexture=frames[i].frame:CreateTexture(nil)
			frames[i].sparkTexture=frames[i].spark:CreateTexture(nil)
		end
		
		if DF_config.spells[i].timerbar==0 then
			frames[i].useConfig=1
		else
			frames[i].useConfig=DF_config.spells[i].timerbar
		end
			
		local level = DF_config.timerbars[frames[i].useConfig].level*10

		barsOrder[i]=i

		-- attribution du cadre parent
		if DF_config.spells[i].timerbar==1 then
			frames[i].frame:SetParent(DF.anchor[3].frame)
		elseif DF_config.spells[i].timerbar==2 then
			frames[i].frame:SetParent(DF.anchor[4].frame)
		end

		useWidth = DF_config.timerbars[frames[i].useConfig].width
		useHeight = DF_config.timerbars[frames[i].useConfig].height

		-- paramétres cadre principal
		frames[i].frame:SetMovable(false)
				
		frames[i].frame:SetWidth(useWidth)
		frames[i].frame:SetHeight(useHeight)
		
		frames[i].frame:ClearAllPoints()
		frames[i].frame:SetPoint("TOPLEFT", DF.anchor[3].frame, "TOPLEFT", 0, -16-((i-1)*useHeight))
		frames[i].frame:SetFrameLevel(level)
		
		if DF_config.timerbars[frames[i].useConfig].border then
			frames[i].frameTexture:ClearAllPoints()
			frames[i].frameTexture:SetAllPoints(frames[i].frame)
			frames[i].frameTexture:SetTexture(DF_config.timerbars[frames[i].useConfig].borderColor.r, DF_config.timerbars[frames[i].useConfig].borderColor.v, DF_config.timerbars[frames[i].useConfig].borderColor.b,DF_config.timerbars[frames[i].useConfig].borderColor.a)
			frames[i].frame.texture=frames[i].frameTexture
		else
			frames[i].frameTexture:ClearAllPoints()
			frames[i].frameTexture:SetAllPoints(frames[i].frame)
			frames[i].frameTexture:SetTexture(DF_config.timerbars[frames[i].useConfig].borderColor.r, DF_config.timerbars[frames[i].useConfig].borderColor.v, DF_config.timerbars[frames[i].useConfig].borderColor.b,0)
			frames[i].frame.texture=frames[i].frameTexture			
		end
		
		-- paramétres background
		frames[i].background:SetWidth(useWidth-DF_config.timerbars[frames[i].useConfig].borderSize*2)
		frames[i].background:SetHeight(useHeight-DF_config.timerbars[frames[i].useConfig].borderSize*2)
		frames[i].background:ClearAllPoints()
		frames[i].background:SetPoint("TOPLEFT", frames[i].frame, "TOPLEFT", DF_config.timerbars[frames[i].useConfig].borderSize, -DF_config.timerbars[frames[i].useConfig].borderSize)
		frames[i].background:SetStatusBarTexture(DF_config.timerbars[frames[i].useConfig].texturePath)
		frames[i].background:SetStatusBarColor(DF_config.spells[i].color.r/3, DF_config.spells[i].color.v/3, DF_config.spells[i].color.b/3, DF_config.spells[i].color.a)
		frames[i].background:SetOrientation("HORIZONTAL")
		frames[i].background:SetFrameLevel(level+2)
		
		-- paramétres foreground
		frames[i].foreground:SetWidth(useWidth-DF_config.timerbars[frames[i].useConfig].borderSize*2)
		frames[i].foreground:SetHeight(useHeight-DF_config.timerbars[frames[i].useConfig].borderSize*2)
		frames[i].foreground:ClearAllPoints()
		frames[i].foreground:SetPoint("TOPLEFT", frames[i].frame, "TOPLEFT", DF_config.timerbars[frames[i].useConfig].borderSize, -DF_config.timerbars[frames[i].useConfig].borderSize)
		frames[i].foreground:SetStatusBarTexture(DF_config.timerbars[frames[i].useConfig].texturePath)
		frames[i].foreground:SetStatusBarColor(DF_config.spells[i].color.r, DF_config.spells[i].color.v, DF_config.spells[i].color.b, DF_config.spells[i].color.a)
		frames[i].foreground:SetOrientation("HORIZONTAL")
		frames[i].foreground:SetMinMaxValues(0, 100)	
		frames[i].foreground:SetFrameLevel(level+3)

		-- paramétres cooldown
		frames[i].cooldown:SetWidth((useWidth-DF_config.timerbars[frames[i].useConfig].borderSize*2)-2)
		frames[i].cooldown:SetHeight(3)
		frames[i].cooldown:ClearAllPoints()
		frames[i].cooldown:SetPoint("BOTTOM", frames[i].foreground, "BOTTOM", DF_config.timerbars[frames[i].useConfig].cdoffsetx, DF_config.timerbars[frames[i].useConfig].cdoffsety)
		frames[i].cooldown:SetStatusBarTexture("Interface\\AddOns\\DroodFocus\\datas\\statusbar3.tga")
		frames[i].cooldown:SetStatusBarColor(DF_config.timerbars[frames[i].useConfig].cdColor.r, DF_config.timerbars[frames[i].useConfig].cdColor.v, DF_config.timerbars[frames[i].useConfig].cdColor.b, DF_config.timerbars[frames[i].useConfig].cdColor.a)
		frames[i].cooldown:SetOrientation("HORIZONTAL")
		frames[i].cooldown:SetMinMaxValues(0, 1)	
		frames[i].cooldown:SetFrameLevel(level+4)

		--frames[i].background:GetStatusBarTexture():SetHorizTile(false)
		--frames[i].foreground:GetStatusBarTexture():SetHorizTile(false)
		--frames[i].cooldown:GetStatusBarTexture():SetHorizTile(false)
		
		frames[i].spark:SetMovable(false)
		frames[i].spark:EnableMouse(false)		
		frames[i].spark:SetWidth(20)
		frames[i].spark:SetHeight(useHeight*2.2)
		frames[i].spark:ClearAllPoints()
		frames[i].spark:SetPoint("LEFT", frames[i].foreground, "LEFT", 0, 0)

		frames[i].sparkTexture:ClearAllPoints()
		frames[i].sparkTexture:SetAllPoints(frames[i].spark)
		frames[i].sparkTexture:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
		frames[i].sparkTexture:SetBlendMode("ADD")
		frames[i].spark.texture=frames[i].sparkTexture		
		frames[i].spark:SetFrameLevel(255)
		
		-- paramétres textes
		DF:MySetFont(frames[i].texts[1],DF_config.timerbars[frames[i].useConfig].font1Path,DF_config.timerbars[frames[i].useConfig].font1Size,"OUTLINE")
		DF:MySetFont(frames[i].texts[2],DF_config.timerbars[frames[i].useConfig].font2Path,DF_config.timerbars[frames[i].useConfig].font2Size,"OUTLINE")
	
		for t = 1,2 do
			frames[i].texts[t]:SetShadowColor(0, 0, 0, 0.75)
			frames[i].texts[t]:SetShadowOffset(0.5, -0.5)
			frames[i].texts[t]:SetTextColor(DF_config.timerbars[frames[i].useConfig].textColor.r, DF_config.timerbars[frames[i].useConfig].textColor.v, DF_config.timerbars[frames[i].useConfig].textColor.b, DF_config.timerbars[frames[i].useConfig].textColor.a)
			frames[i].texts[t]:SetText("")
			frames[i].texts[t]:ClearAllPoints()
		end
	
		frames[i].texts[1]:SetPoint("LEFT", frames[i].foreground,"LEFT", DF_config.timerbars[frames[i].useConfig].textsoffsets[1].offsetx, DF_config.timerbars[frames[i].useConfig].textsoffsets[1].offsety)
		frames[i].texts[2]:SetPoint("RIGHT", frames[i].foreground,"RIGHT", DF_config.timerbars[frames[i].useConfig].textsoffsets[2].offsetx, DF_config.timerbars[frames[i].useConfig].textsoffsets[2].offsety)

		frames[i].texts[1]:SetText("SPELL")
		frames[i].texts[2]:SetText("88")

		if not DF_config.timerbar.enable or DF_config.spells[i].timerbar~=0 then
			frames[i].frame:Hide()
		else
			frames[i].frame:Show()
		end
	
		if not DF_config.timerbars[frames[i].useConfig].showSpark then
			frames[i].spark:Hide()
		else
			frames[i].spark:Show()
		end
		
	end
	
end

-- gestion de l'animation
function DF:timerbars_update()
	
	if not DF_config.timerbar.enable then return end
		
	local mini=1
	local i
	local form = nil
	local currentForm = DF:currentForm()	
	local texte =""
	local cursor =0
	local sparckx=0
	
	local barsCounter=1
	
	local barsCounter1=1
	local barsCounter2=1
	
	local nbBars = 0
	local num=0
	local numPrec=0
	local save =0
	
	local debutCD=nil
	local dureeCD=nil
	
	local largeur=0
	local hauteur=0
	local activeAlpha=0
	local inactiveAlpha=0
	local inactiveCd=0
	
	nbSpells = getn(DF_config.spells)
	-- anime
	for i = 1,nbSpells do

		largeur = DF_config.timerbars[frames[i].useConfig].width-DF_config.timerbars[frames[i].useConfig].borderSize*2
		hauteur = DF_config.timerbars[frames[i].useConfig].height
		activeAlpha=DF_config.timerbars[frames[i].useConfig].activeAlpha
		inactiveAlpha=DF_config.timerbars[frames[i].useConfig].inactiveAlpha
		inactiveCd=DF_config.timerbars[frames[i].useConfig].activeAlphaCD
		
		form = DF_config.spells[i].form
	 	
		-- fin si pas bonne forme
		if DF_config.spells[i].timerbar~=0 and (DF:form_goofForm(form,currentForm) or DF_config.spells[i].alwaysVisible==true) then

			frames[i].frame:Show()
			if DF_config.spells[i].abiUserText=="" then
				texte = DF_config.spells[i].abiSpelltext
			else
				texte = DF_config.spells[i].abiUserText
			end
			
			if DF_config.spells[i].abiStack>0 then
				texte=texte.." x"..DF:numbers(DF_config.spells[i].abiStack)
			end			
		
			frames[i].texts[1]:SetText(texte)
			frames[i].alpha = frames[i].alpha - 0.025
			
			-- màj texte temps restant
			if DF_config.spells[i].abiTimeLeft>0 then
				
				if DF_config.spells[i].abiTimeLeft>100000 then
					frames[i].texts[2]:SetText("")
				else
					frames[i].texts[2]:SetText(DF:minutes(DF_config.spells[i].abiTimeLeft))
				end
				
				if frames[i].alpha<activeAlpha then
					frames[i].alpha=activeAlpha
				end
		
			else
				
				frames[i].texts[2]:SetText("")
				
				if frames[i].alpha<inactiveAlpha then
					frames[i].alpha=inactiveAlpha
				end				
			
			end
	
			if (DF.configmode) then 
				if frames[i].alpha<activeAlpha then
					frames[i].alpha=activeAlpha
				end				
			end
			
			frames[i].frame:SetAlpha(frames[i].alpha)
			
			debutCD,dureeCD=DF:cooldown_getCD(DF_config.spells[i].abiSpellId)
			if debutCD>0 and dureeCD>0 and DF_config.spells[i].showcd then
				
				restant = (debutCD+dureeCD)-DF.currentTime

				if restant<0 then
					restant=0
					frames[i].cooldown:Hide()
				else
					if frames[i].alpha<inactiveCd then
						frames[i].alpha=inactiveCd
					end
					frames[i].frame:SetAlpha(frames[i].alpha)				
					frames[i].cooldown:Show()					
					frames[i].cooldown:SetValue(restant/dureeCD)
				end	
				
			else
				
				frames[i].cooldown:Hide()
				
			end			
			
			if (DF_config.timerbars[frames[i].useConfig].prop) then
				
				if DF_config.spells[i].abiDuration==0 then
					
					if DF_config.spells[i].abiTimeLeft>100000 then
						cursor=100
					else
						cursor=0
					end
					
				else
					
					cursor = (DF_config.spells[i].abiTimeLeft/DF_config.spells[i].abiDuration)*100
					
				end
			else	
						
				if DF_config.spells[i].abiTimeLeft<=DF_config.timerbars[frames[i].useConfig].timeline then
					cursor = (((largeur/DF_config.timerbars[frames[i].useConfig].timeline)*DF_config.spells[i].abiTimeLeft)/largeur)*100
				else
					cursor=100
				end
				
			end
			
			if (DF.configmode) then
				cursor=50
				frames[i].texts[2]:SetText("0:00")
				frames[i].cooldown:SetValue(0.75)
				frames[i].cooldown:Show()
			end
			
			frames[i].foreground:SetValue(cursor)	
							
			DF:timerbars_sparck(cursor,i)
			
		else
			
			frames[i].frame:Hide()
			
		end	
	end		
	
	-- classement barres par temps restant
	-- a chaque cycle les barres remonte si le temps est plus court

	for i = 2,nbSpells do
		
		if DF_config.timerbars[frames[i].useConfig].orderByTime then
		
			num = barsOrder[i]
			numPrec = barsOrder[i-1]
	
			cd1=0
			dur1=0
			cd2=0
			dur2=0	
			rt1=0
			rt2=0
			
			if DF_config.spells[num].showcd then
				cd1,dur1=DF:cooldown_getCD(DF_config.spells[num].abiSpellId)
				rt1=(cd1+dur1)-DF.currentTime
			end
			
			if DF_config.spells[numPrec].showcd then
				cd2,dur2=DF:cooldown_getCD(DF_config.spells[numPrec].abiSpellId)
				rt2=(cd2+dur2)-DF.currentTime
			end
	
			if rt1<0 then rt1=0 end
			if rt2<0 then rt2=0 end
	
			temporaire = DF_config.spells[num].abiTimeLeft
			if temporaire==0 and rt1==0 then -- inative pas sous cd
				if DF_config.timerbars[frames[num].useConfig].growup then
					temps=400000
				else
					temps=0
				end
			elseif temporaire==0 and rt1>0 then -- inactive sous cd
				temps=rt1+100000
			elseif temporaire>0 and temporaire<100000 then -- normal active
				temps=temporaire+200000
			elseif temporaire>100000 then -- aura active
				temps=300000
			end
	
			temporaire = DF_config.spells[numPrec].abiTimeLeft
			if temporaire==0 and rt2==0 then -- inative pas sous cd
				if DF_config.timerbars[frames[numPrec].useConfig].growup then
					temps2=400000
				else
					temps2=0
				end
			elseif temporaire==0 and rt2>0 then -- inactive sous cd
				temps2=rt2+100000
			elseif temporaire>0 and temporaire<100000 then -- normal active
				temps2=temporaire+200000
			elseif temporaire>100000 then -- aura active
				temps2=300000
			end
	
			-- si temps i inférieur a temps i-1, on échange les places
			if temps<temps2 then
				
				-- inverse
				barsOrder[i]= numPrec
				barsOrder[i-1] = num
				
			end
			
		end
		
	end
		
	-- trouve le nb de barre
	nbbars1=0
	nbbars2=0
	for i = 1,nbSpells do
		
		num = barsOrder[i]
		form = DF_config.spells[num].form
		
		if DF_config.spells[num].timerbar~=0 and (DF:form_goofForm(form,currentForm) or DF_config.spells[num].alwaysVisible==true) then
			if DF_config.spells[num].timerbar==1 then
				nbbars1=nbbars1+1
			else
				nbbars2=nbbars2+1
			end
		end

	end
	nbbars1=nbbars1-1
	nbbars2=nbbars2-1
	
	-- replacement barres dans leur ancres respectives et a la bonne position
	barsCounter1=0
	barsCounter2=0
	for i = 1,nbSpells do
		
		-- num = barre a replacer
		num = barsOrder[i]
		
		form = DF_config.spells[num].form
		
		if DF_config.spells[num].timerbar~=0 and (DF:form_goofForm(form,currentForm) or DF_config.spells[num].alwaysVisible==true) then
			
			if DF_config.spells[num].timerbar==1 then
				
				-- replacement dans ancre 3
				frames[num].frame:ClearAllPoints()
				if DF_config.timerbars[frames[num].useConfig].stackup1==false then
					posy=-8-(barsCounter1*DF_config.timerbars[frames[num].useConfig].height)
				else
					posy=12+((nbbars1-barsCounter1)*DF_config.timerbars[frames[num].useConfig].height)
				end	
				frames[num].frame:SetPoint("TOPLEFT", DF.anchor[3].frame, "TOPLEFT", 8,posy )
				barsCounter1=barsCounter1+1
				
			elseif DF_config.spells[num].timerbar==2 then
	
				-- replacement dans ancre 4
				frames[num].frame:ClearAllPoints()
				if DF_config.timerbars[frames[num].useConfig].stackup1==false then
					posy=-8-(barsCounter2*DF_config.timerbars[frames[num].useConfig].height)
				else
					posy=12+((nbbars2-barsCounter2)*DF_config.timerbars[frames[num].useConfig].height)
				end	
				frames[num].frame:SetPoint("TOPLEFT", DF.anchor[4].frame, "TOPLEFT", 8, posy)
				barsCounter2=barsCounter2+1
				
			end
			
		end
		
	end
	
end

function DF:timerbars_sparck(cursor,num)
	local largeur=DF_config.timerbars[frames[num].useConfig].width-(DF_config.timerbars[frames[num].useConfig].borderSize*2)

	if cursor>0 and cursor<100 and DF_config.timerbars[frames[num].useConfig].showSpark then
		sparckx=((cursor/100)*largeur)-10
		frames[num].spark:SetPoint("LEFT", frames[num].foreground, "LEFT", sparckx, -1)
		frames[num].spark:Show()
	else
		frames[num].spark:Hide()
	end
end

-- enable/disable déplacement du cadre avec la souris
function DF:timerbars_toogle_lock(flag)
	nbSpells = getn(DF_config.spells)
	for i = 1,nbSpells do
		frames[i].frame:EnableMouse(flag)
	end
	
end

function DF:timerbar_reinit()
	
	DF:init_timerbars_frame()
	
end